---
title: Tree map view
slug: Tools/Memory/Tree_map_view
---
<div>{{ToolsSidebar}}</div><div class="geckoVersionNote">
<p>The Tree map view is new in Firefox 48.</p>
</div>

<p>The Tree map view provides a visual representation of the snapshot, that helps you quickly get an idea of which objects are using the most memory.</p>

<p>A treemap displays <a href="https://en.wikipedia.org/wiki/Treemapping">"hierarchical (tree-structured) data as a set of nested rectangles"</a>. The size of the rectangles corresponds to some quantitative aspect of the data.</p>

<p>For the treemaps shown in the Memory tool, things on the heap are divided at the top level into four categories:</p>

<ul>
 <li><strong>objects</strong>: JavaScript and DOM objects, such as <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">Function</a></code>, <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">Object</a></code>, or <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array">Array</a></code>, and DOM types like <code><a href="/en-US/docs/Web/API/Window">Window</a></code> and <code><a href="/en-US/docs/Web/API/HTMLDivElement">HTMLDivElement</a></code>.</li>
 <li><strong>scripts</strong>: JavaScript sources loaded by the page.</li>
 <li><strong>strings</strong></li>
 <li><strong>other</strong>: this includes internal <a href="/en-US/docs/Mozilla/Projects/SpiderMonkey">SpiderMonkey</a> objects.</li>
</ul>

<p>Each category is represented with a rectangle, and the size of the rectangle corresponds to the proportion of the heap occupied by items in that category. This means you can quickly get an idea of roughly what sorts of things allocated by your site are using the most memory.</p>

<p>Within top-level categories:</p>

<ul>
 <li><strong>objects</strong> is further divided by the object's type.</li>
 <li><strong>scripts</strong> is further subdivided by the script's origin. It also includes a separate rectangle for code that can't be correlated with a file, such as JIT-optimized code.</li>
 <li><strong>other</strong> is further subdivided by the object's type.</li>
</ul>

<p>Here are some example snapshots, as they appear in the Tree map view:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13048/treemap-domnodes.png" style="display: block; margin-left: auto; margin-right: auto; width: 844px;"></p>

<p>This treemap is from the <a href="/en-US/docs/Tools/Memory/DOM_allocation_example">DOM allocation example</a>, which runs a script that creates a large number of DOM nodes (200 <code><a href="/en-US/docs/Web/API/HTMLDivElement">HTMLDivElement</a></code> objects and 4000 <code><a href="/en-US/docs/Web/API/HTMLSpanElement">HTMLSpanElement</a></code> objects). You can see how almost all the heap usage is from the <code>HTMLSpanElement</code> objects that it creates.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13046/treemap-monsters.png" style="display: block; margin-left: auto; margin-right: auto; width: 844px;"></p>

<p>This treemap is from the <a href="/en-US/docs/Tools/Memory/Monster_example">monster allocation example</a>, which creates three arrays, each containing 5000 monsters, each monster having a randomly-generated name. You can see that most of the heap is occupied by the strings used for the monsters' names, and the objects used to contain the monsters' other attributes.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13050/treemap-bbc.png" style="display: block; margin-left: auto; margin-right: auto; width: 844px;"></p>

<p>This treemap is from <a href="http://www.bbc.com/">http://www.bbc.com/</a>, and is probably more representative of real life than the examples. You can see the much larger proportion of the heap occupied by scripts, that are loaded from a large number of origins.</p>
